/*
*  Form variables
*
*
*
*
*
*/

/* Misc */
var NC_INSERT_TOGGLE = false;

/* form driver commands */
var REQ_NEXT_PAGE      = KEY_MAX + 1; /* move to next page              */
var REQ_PREV_PAGE      = KEY_MAX + 2; /* move to previous page  */
var REQ_FIRST_PAGE     = KEY_MAX + 3; /* move to first page             */
var REQ_LAST_PAGE      = KEY_MAX + 4; /* move to last page              */
var REQ_NEXT_FIELD     = KEY_MAX + 5;   /* move to next field           */
var REQ_PREV_FIELD     = KEY_MAX + 6;   /* move to previous field       */
var REQ_FIRST_FIELD    = KEY_MAX + 7;   /* move to first field          */
var REQ_LAST_FIELD     = KEY_MAX + 8;   /* move to last field           */
var REQ_SNEXT_FIELD    = KEY_MAX + 9;   /* move to sorted next field    */
var REQ_SPREV_FIELD    = KEY_MAX + 10;  /* move to sorted prev field    */
var REQ_SFIRST_FIELD   = KEY_MAX + 11;  /*  move to sorted first field  */
var REQ_SLAST_FIELD    = KEY_MAX + 12;  /*  move to sorted last field   */
var REQ_LEFT_FIELD     = KEY_MAX + 13;  /*  move to left to field       */
var REQ_RIGHT_FIELD    = KEY_MAX + 14;  /*  move to right to field      */
var REQ_UP_FIELD       = KEY_MAX + 15;  /*  move to up to field         */
var REQ_DOWN_FIELD     = KEY_MAX + 16;  /*  move to down to field       */
var REQ_NEXT_CHAR      = KEY_MAX + 17;  /*  move to next char in field  */
var REQ_PREV_CHAR      = KEY_MAX + 18;  /*  move to prev char in field  */
var REQ_NEXT_LINE      = KEY_MAX + 19;  /*  move to next line in field  */

var REQ_PREV_LINE      = KEY_MAX + 20;  /*  move to prev line in field  */
var REQ_NEXT_WORD      = KEY_MAX + 21;  /*  move to next word in field  */
var REQ_PREV_WORD      = KEY_MAX + 22;  /*  move to prev word in field  */
var REQ_BEG_FIELD      = KEY_MAX + 23;  /*  move to first char in field */
var REQ_END_FIELD      = KEY_MAX + 24;  /*  move after last char in fld */
var REQ_BEG_LINE       = KEY_MAX + 25;  /*  move to beginning of line   */
var REQ_END_LINE       = KEY_MAX + 26;  /*  move after last char in line        */
var REQ_LEFT_CHAR      = KEY_MAX + 27;  /*  move left in field          */
var REQ_RIGHT_CHAR     = KEY_MAX + 28;  /*  move right in field         */
var REQ_UP_CHAR        = KEY_MAX + 29;  /*  move up in field            */
var REQ_DOWN_CHAR      = KEY_MAX + 30;  /*  move down in field          */

var REQ_NEW_LINE       = KEY_MAX + 31;  /*  insert/overlay new line     */
var REQ_INS_CHAR       = KEY_MAX + 32;  /*  insert blank char at cursor */
var REQ_INS_LINE       = KEY_MAX + 33;  /*  insert blank line at cursor */
var REQ_DEL_CHAR       = KEY_MAX + 34;  /*  delete char at cursor       */
var REQ_DEL_PREV       = KEY_MAX + 35;  /*  delete char before cursor   */
var REQ_DEL_LINE       = KEY_MAX + 36;  /*  delete line at cursor       */
var REQ_DEL_WORD       = KEY_MAX + 37;  /*  delete word at cursor       */
var REQ_CLR_EOL        = KEY_MAX + 38;  /*  clear to end of line        */
var REQ_CLR_EOS        = KEY_MAX + 58;  /*  clear to end of screen      */
var REQ_CLR_EOF        = KEY_MAX + 39;  /*  clear to end of field       */
var REQ_CLR_FIELD      = KEY_MAX + 40;  /*  clear entire field          */
var REQ_OVL_MODE       = KEY_MAX + 41;  /*  begin overlay mode          */
var REQ_INS_MODE       = KEY_MAX + 42;  /*  begin insert mode           */
var REQ_SCR_FLINE      = KEY_MAX + 43;  /*  scroll field forward a line */
var REQ_SCR_BLINE      = KEY_MAX + 44;  /*  scroll field backward a line        */
var REQ_SCR_FPAGE      = KEY_MAX + 45;  /*  scroll field forward a page */
var REQ_SCR_BPAGE      = KEY_MAX + 46;  /*  scroll field backward a page        */
var REQ_SCR_FHPAGE     = KEY_MAX + 47;  /* scroll field forward  half page */
var REQ_SCR_BHPAGE     = KEY_MAX + 48;  /* scroll field backward half page */
var REQ_SCR_FCHAR      = KEY_MAX + 49;  /* horizontal scroll char       */
var REQ_SCR_BCHAR      = KEY_MAX + 50;  /* horizontal scroll char       */
var REQ_SCR_HFLINE     = KEY_MAX + 51;  /* horizontal scroll line       */
var REQ_SCR_HBLINE     = KEY_MAX + 52;  /* horizontal scroll line       */
var REQ_SCR_HFHALF     = KEY_MAX + 53;  /* horizontal scroll half line  */
var REQ_SCR_HBHALF     = KEY_MAX + 54;  /* horizontal scroll half line  */

var REQ_VALIDATION     = KEY_MAX + 55;  /*  validate field              */
var REQ_NEXT_CHOICE    = KEY_MAX + 56;  /*  display next field choice   */
var REQ_PREV_CHOICE    = KEY_MAX + 57;  /*  display prev field choice   */
var REQ_CAN_NEXT_CHAR  = KEY_MAX + 58;  /*  Can we move to next char in field  */
var REQ_CAN_PREV_CHAR  = KEY_MAX + 59;  /*  Can we move to prev char in field  */

var MIN_FORM_COMMAND   = KEY_MAX + 1;   /*  used by form_driver */
var MAX_FORM_COMMAND   = KEY_MAX + 60;  /*  used by form_driver */

var E_OK               =  0;
var E_SYSTEM_ERROR     = -1;
var E_BAD_ARGUMENT     = -2;
var E_POSTED           = -3;
var E_CONNECTED        = -4;
var E_BAD_STATE        = -5;
var E_NO_ROOM          = -6;
var E_NOT_POSTED       = -7;
var E_UNKNOWN_COMMAND  = -8;
var E_NO_MATCH         = -9;
var E_NOT_SELECTABLE   = -10;
var E_NOT_CONNECTED    = -11;
var E_REQUEST_DENIED   = -12;
var E_INVALID_FIELD    = -13;
var E_CURRENT          = -14;

var _POSTED            = 0x1;
var _IN_DRIVER         = 0x2;
var _HAS_HORZ_SCROLL   = 0x4;
var _HORZ_SCROLL_TIMER = 0;
/*
*  Object: fieldnode ()
*
*  Description: Holds info about on field element
*
*/
function fieldnode (parm_field)
{
    this.element = parm_field;

    /* If this is a select field I sent over the size of the values in the name */
    if (parm_field.tagName == "SELECT")
    {
      this.maxgrow = parm_field.name.substring(4);
      this.name = parm_field.name.substring(0,4);
      parm_field.name = this.name;
    }
    else
    {
      this.name = parm_field.name;
      this.maxgrow = parm_field.maxLength;
    }

    this.org_back = parm_field.style.background;
    this.org_fore = parm_field.style.color;
    this.cols = parm_field.size;
    this.length = parm_field.value.length;
    this.cur_col = 0
    if (parm_field.style.height == undefined || parm_field.style.height == void 0 || parm_field.style.height == "") {
        this.height = 1;
    }
    else
    {
        if (parm_field.style.height.indexOf('px') > 0) {
          this.height = parseInt (parm_field.style.height) / NC_ROW_PIXEL;
        }
        else {
          this.height = parseInt (parm_field.style.height);
        }
    }

    if (parm_field.style.top.indexOf('px') > 0) {
      this.top = parseInt (parm_field.style.top) / NC_ROW_PIXEL;
    }
    else {
      this.top = parseInt (parm_field.style.top);
    }

    if (parm_field.style.left.indexOf('px') > 0) {
      this.left = parseInt (parm_field.style.left) / NC_COL_PIXEL;
    }
    else {
      this.left = parseInt (parm_field.style.left);
    }

    this.nrow = 0;
    this.buf = parm_field.value; 
}
