/*
*  JavaScript Implementation: jscurses
*
* Description:
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/

/*
* Description: JScurses variables
*
*/

/* Global function */
var _nc_Buffer_Key;         /* Stores type-ahead keys */

/* misc */
var NC_FONT_TABLE = new Array(
  "LucidaTypewriter",   /* 0 */
  "Serif",              /* 1 */
  "Sans-serif",         /* 2 */
  "Courier"             /* 3 */
);

/* Default pixel sizes on LucTyp 12pt */
var NC_LINUX_ROW_PIXEL = "19";
var NC_LINUX_COL_PIXEL = "11";
var NC_WIN_ROW_PIXEL = "16";
var NC_WIN_COL_PIXEL = "10";

var NC_DEF_FONT_SIZE = "12";
var NC_DEF_FONT_NAME = "0";
var NC_DEF_ROW_PIXEL;
var NC_DEF_COL_PIXEL;


var NC_FONT_NAME;
var NC_FONT_SIZE;
var NC_ROW_PIXEL;
var NC_COL_PIXEL;
var NC_BROWSER_OS;
var NC_BROWSER_TYPE;

var  KEY_DOWN  =  402;     /* down-arrow key */
var  KEY_UP    =  403;     /* up-arrow key */
var  KEY_LEFT  =  404;     /* left-arrow key */
var  KEY_RIGHT =  405;     /* right-arrow key */
var  KEY_HOME  =  406;     /* home key */
var  KEY_BACKSPACE = 407;  /* backspace key */
var  KEY_F0    =  410;     /* Function keys.  Space for 64 */
const  KEY_F   =  function (n) { return KEY_F0 + n }; /* Value of function key n */
var  KEY_DL    =  510;     /* delete-line key */
var  KEY_IL    =  511;     /* insert-line key */
var  KEY_DC    =  512;     /* delete-character key */
var  KEY_IC    =  513;     /* insert-character key */
var  KEY_EIC   =  514;     /* sent by rmir or smir in insert mode */
var  KEY_CLEAR =  515;     /* clear-screen or erase key */
var  KEY_EOS   =  516;     /* clear-to-end-of-screen key */
var  KEY_EOL   =  517;     /* clear-to-end-of-line key */
var  KEY_SF    =  520;     /* scroll-forward key */
var  KEY_SR    =  521;     /* scroll-backward key */
var  KEY_NPAGE =  522;     /* next-page key */
var  KEY_PPAGE =  523;     /* previous-page key */
var  KEY_STAB  =  524;     /* set-tab key */
var  KEY_CTAB  =  525;     /* clear-tab key */
var  KEY_CATAB =  526;     /* clear-all-tabs key */
var  KEY_ENTER =  527;     /* enter/send key */
var  KEY_PRINT =  532;     /* print key */
var  KEY_LL    =  533;     /* lower-left key (home down) */
var  KEY_A1    =  534;     /* upper left of keypad */
var  KEY_A3    =  535;     /* upper right of keypad */
var  KEY_B2    =  536;     /* center of keypad */
var  KEY_C1    =  537;     /* lower left of keypad */
var  KEY_C3    =  540;     /* lower right of keypad */
var  KEY_BTAB  =  541;     /* back-tab key */
var  KEY_BEG   =  542;     /* begin key */
var  KEY_CANCEL  =  543;     /* cancel key */
var  KEY_CLOSE   =  544;     /* close key */
var  KEY_COMMAND =  545;     /* command key */
var  KEY_COPY    =  546;     /* copy key */
var  KEY_CREATE  =  547;     /* create key */
var  KEY_END     =  550;     /* end key */
var  KEY_EXIT    =  551;     /* exit key */
var  KEY_FIND    =  552;     /* find key */
var  KEY_HELP    =  553;     /* help key */
var  KEY_MARK    =  554;     /* mark key */
var  KEY_MESSAGE =  555;     /* message key */
var  KEY_MOVE    =  556;     /* move key */
var  KEY_NEXT    =  557;     /* next key */
var  KEY_OPEN    =  560;     /* open key */
var  KEY_OPTIONS =  561;     /* options key */
var  KEY_PREVIOUS = 562;     /* previous key */
var  KEY_REDO    =  563;     /* redo key */
var  KEY_REFERENCE =564;     /* reference key */
var  KEY_REFRESH =  565;     /* refresh key */
var  KEY_REPLACE =  566;     /* replace key */
var  KEY_RESTART =  567;     /* restart key */
var  KEY_RESUME  =  570;     /* resume key */
var  KEY_SAVE    =  571;     /* save key */
var  KEY_SBEG    =  572;     /* shifted begin key */
var  KEY_SCANCEL =  573;     /* shifted cancel key */
var  KEY_SCOMMAND = 574;     /* shifted command key */
var  KEY_SCOPY   =  575;     /* shifted copy key */
var  KEY_SCREATE =  576;     /* shifted create key */
var  KEY_SDC     =  577;     /* shifted delete-character key */
var  KEY_SDL     =  600;     /* shifted delete-line key */
var  KEY_SELECT  =  601;     /* select key */
var  KEY_SEND    =  602;     /* shifted end key */
var  KEY_SEOL    =  603;     /* shifted clear-to-end-of-line key */
var  KEY_SEXIT   =  604;     /* shifted exit key */
var  KEY_SFIND   =  605;     /* shifted find key */
var  KEY_SHELP   =  606;     /* shifted help key */
var  KEY_SHOME   =  607;     /* shifted home key */
var  KEY_SIC     =  610;     /* shifted insert-character key */
var  KEY_SLEFT   =  611;     /* shifted left-arrow key */
var  KEY_SMESSAGE = 612;     /* shifted message key */
var  KEY_SMOVE   =  613;     /* shifted move key */
var  KEY_SNEXT   =  614;     /* shifted next key */
var  KEY_SOPTIONS = 615;     /* shifted options key */
var  KEY_SPREVIOUS = 616;    /* shifted previous key */
var  KEY_SPRINT   = 617;     /* shifted print key */
var  KEY_SREDO    = 620;     /* shifted redo key */
var  KEY_SREPLACE = 621;     /* shifted replace key */
var  KEY_SRIGHT   = 622;     /* shifted right-arrow key */
var  KEY_SRSUME   = 623;     /* shifted resume key */
var  KEY_SSAVE    = 624;     /* shifted save key */
var  KEY_SSUSPEND = 625;     /* shifted suspend key */
var  KEY_SUNDO =    626;     /* shifted undo key */
var  KEY_SUSPEND =  627;     /* suspend key */
var  KEY_UNDO    =  630;     /* undo key */
var  KEY_MOUSE   =  631;     /* Mouse event has occurred */
var  KEY_RESIZE  =  632;     /* Terminal resize event */
var  KEY_EVENT   =  633;     /* We were interrupted by an event */

/* Hacks */
var  KEY_CAPSLOCK =  634;     /* Capslock key */
var  KEY_TAB      =  635;     /* Tab key */
var  KEY_ESC      =  636;     /* Esc key */

var  KEY_MAX      =  777;

/* Define keycode names */

var KEYCODE_BACKSPACE = 8;
var KEYCODE_BTAB  = 9;           /* Shift tab */
var KEYCODE_TAB   = 9;
var KEYCODE_ENTER = 13;
var KEYCODE_CAPSLOCK = 20;
var KEYCODE_ESC   = 27;

/*
* These keycodes share the
* same code with regular ascii
* characters
*/
/*****************************/
var KEYCODE_PPAGE = 33;          /* Page up */
var KEYCODE_NPAGE = 34;          /* Page down */
var KEYCODE_END   = 35;
var KEYCODE_HOME  = 36;

var KEYCODE_LEFT  = 37;
var KEYCODE_UP    = 38;
var KEYCODE_RIGHT = 39;
var KEYCODE_DOWN  = 40;

var KEYCODE_IC    = 45;          /* Insert key */
var KEYCODE_DC    = 46;          /* Delete key */

var KEYCODE_F1    = 112;
var KEYCODE_F2    = 113;
var KEYCODE_F3    = 114;
var KEYCODE_F4    = 115;
var KEYCODE_F5    = 116;
var KEYCODE_F6    = 117;
var KEYCODE_F7    = 118;
var KEYCODE_F8    = 119;
var KEYCODE_F9    = 120;
var KEYCODE_F10   = 121;
var KEYCODE_F11   = 122;
var KEYCODE_F12   = 123;
var KEYCODE_F13   = 124;
var KEYCODE_F14   = 125;
var KEYCODE_F15   = 126;
var KEYCODE_F16   = 127;
var KEYCODE_F17   = 128;
var KEYCODE_F18   = 129;
var KEYCODE_F19   = 130;
var KEYCODE_F20   = 131;
var KEYCODE_F21   = 132;
var KEYCODE_F22   = 133;
var KEYCODE_F23   = 134;
var KEYCODE_F24   = 135;
/*****************************/

var KEYCODE_SHIFT   = 16;
var KEYCODE_CTRL    = 17;
var KEYCODE_ALT     = 18;
var KEYCODE_SCROLL  = 145;

/* Attribs */
var A_NORMAL    = 1;
var A_STANDOUT  = 2;
var A_SELECT    = 6;

var E_OK                 = 0;
var E_SYSTEM_ERROR       = -1;
var E_BAD_ARGUMENT       = -2;
var E_POSTED             = -3;
var E_CONNECTED          = -4;
var E_BAD_STATE          = -5;
var E_NO_ROOM            = -6;
var E_NOT_POSTED         = -7;
var E_UNKNOWN_COMMAND    = -8;
var E_NO_MATCH           = -9;
var E_NOT_SELECTABLE     = -10;
var E_NOT_CONNECTED      = -11;
var E_REQUEST_DENIED     = -12;
var E_INVALID_FIELD      = -13;
var E_CURRENT            = -14;
