/*
*  JavaScript Implementation: jscurses
*
* Description:
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/


/*
*  Function: initscr ()
*
*  Description: Sets and checks various things
*
*/
function initscr ()
{
  trace ("initscr ()");

  _nc_Buffer_Key = new _nc_Buffer_Key_Obj();

  if (navigator.userAgent.indexOf('Firefox') > 0) {
    NC_BROWSER_TYPE = "FF";
  }
  else if (navigator.appName == "Netscape") {
    NC_BROWSER_TYPE = "NN";
  }
  else if (navigator.appName == "Microsoft Internet Explorer") {
    NC_BROWSER_TYPE = "IE";
  }
  else {
    NC_BROWSER_TYPE = "FF";
  }

  if (navigator.appVersion.indexOf('Win') > 0) {
    NC_BROWSER_OS = "W";
    NC_DEF_ROW_PIXEL = NC_WIN_ROW_PIXEL;
    NC_DEF_COL_PIXEL = NC_WIN_COL_PIXEL;
  }
  else if (navigator.appVersion.indexOf('Mac') > 0) {
    NC_BROWSER_OS = "M";
    NC_DEF_ROW_PIXEL = NC_WIN_ROW_PIXEL;
    NC_DEF_COL_PIXEL = NC_WIN_COL_PIXEL;
  }
  else if (navigator.userAgent.indexOf('Linux') > 0) {
    NC_BROWSER_OS = "L";
    NC_DEF_ROW_PIXEL = NC_LINUX_ROW_PIXEL;
    NC_DEF_COL_PIXEL = NC_LINUX_COL_PIXEL;
  }

  if (!(NC_FONT_NAME = _nc_Read_Cookie("NC_FONT_NAME")))
  {
    NC_FONT_NAME = _nc_Create_Cookie("NC_FONT_NAME",NC_DEF_FONT_NAME,999);
  }

  if (!(NC_FONT_SIZE = _nc_Read_Cookie("NC_FONT_SIZE")))
  {
    NC_FONT_SIZE = _nc_Create_Cookie("NC_FONT_SIZE",NC_DEF_FONT_SIZE,999);
  }

  if (!(NC_ROW_PIXEL = _nc_Read_Cookie("NC_ROW_PIXEL")))
  {
    NC_ROW_PIXEL = _nc_Create_Cookie("NC_ROW_PIXEL",NC_DEF_ROW_PIXEL,999);
  }

  if (!(NC_COL_PIXEL = _nc_Read_Cookie("NC_COL_PIXEL")))
  {
    NC_COL_PIXEL = _nc_Create_Cookie("NC_COL_PIXEL",NC_DEF_COL_PIXEL,999);
  }
}

function _nc_Create_Cookie(name,value,days)
{
  trace ("_nc_Create_Cookie ("+name+", "+value+" ,"+days+")");

  if (days)
  {
    var date = new Date();
    date.setTime(date.getTime()+(days*24*60*60*1000));
    var expires = "; expires="+date.toGMTString();
  }
  else
  {
    var expires = "";
  }
  document.cookie = name+"="+value+expires+"; path=/";
  return (value);
}

function _nc_Read_Cookie(name)
{
  trace ("_nc_Read_Cookie ("+name+")");

  /* Get "name=" constant */
  var nameEQ = name + "=";

  /* cookies contains all the cookies */
  var cookies = document.cookie.split(';');
  var pos;

  trace ("_nc_Read_Cookie: cookies: ("+cookies+")");

  for(var i=0; i < cookies.length; i++)
  {
    if ((pos = cookies[i].indexOf(nameEQ)) >= 0)
    {
      return (cookies[i].substring(nameEQ.length + pos));
    }
  }
  return null;
}

function _nc_Erase_Cookie(name) {
  _nc_Create_Cookie(name,"",-1);
}
