/*
*  JavaScript Implementation: jscurses
*
* Description: newwin functions
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/


/*
*  Function: _nc_New_Win_Obj ()
*
*  Description: Window object
*
*/
function _nc_New_Win_Obj ()
{
  this.win = document.createElement("div");
}


/*
*  Function: newwin ()
*
*  Description: Create virtual windows via <div> statements
*
*/
function newwin (parm_num_lines, parm_num_columns, parm_begy, parm_begx)
{
  var new_win;

  trace ("newwin ("+parm_num_lines+", "+parm_num_columns+", "+parm_begy+", "+parm_begx+")");
  
  new_win = new _nc_New_Win_Obj ();
  
  new_win.win.style.position = "absolute";
  if (parm_num_lines > 0) {
    new_win.win.style.height = (parm_num_lines * NC_ROW_PIXEL)+"px";
  }
  if (parm_num_columns > 0) {
    new_win.win.style.width = (parm_num_columns * NC_COL_PIXEL)+"px";
  }
  new_win.win.style.top = (parm_begy * NC_ROW_PIXEL)+"px";
  new_win.win.style.left = (parm_begx * NC_COL_PIXEL)+"px";

  document.getElementById("body").appendChild(new_win.win);
  return (new_win);
}

